// simple.vert

#extension GL_EXT_gpu_shader4 : enable

// vertex shader of carttond shading

void main(void)
{
    // _WŌvZ 
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);
    vec3 lightVec = normalize(gl_LightSource[0].position.xyz/* - position*/);

    float dis = length(position);

    // ʒuWWϊ
    gl_Position = ftransform();
        
    // @ƌxNgƂ̓(sp)
    vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
    vec3 light = normalize(gl_LightSource[0].position.xyz);
    float lgtdot = dot(light, normal);

    // @ƎxNgƂ̓
    vec3 eye = - normalize(vec3(gl_ModelViewMatrix * gl_Vertex));
    float eyedot = dot(eye, normal);

    float diffuse = dot(lightVec, normal);
    float specular = 0;
    if (diffuse > 0.0){
	// ˃xNgɂXyL[ 
	vec3 viewVec = normalize(-position);
        vec3 reflectVec = reflect(-lightVec, normal);
        specular = pow(max(dot(viewVec, reflectVec), 0.0), 
		       gl_FrontMaterial.shininess);
    }
    
    // eNX`WɊ蓖Ă
    gl_TexCoord[0].s = lgtdot * 0.8 + specular;//
    gl_TexCoord[0].t = eyedot * eyedot / (1 + min(dis/10, 1.0));
}

