// simple.vert

#extension GL_EXT_gpu_shader4 : enable

// vertex shader of gouraud shading

#define USE_REFLECTION (1)  /* XyL[vZɔ˃xNggp */

void main(void)
{
    // _WŌvZ 
    vec3 position = vec3(gl_ModelViewMatrix * gl_Vertex);
    vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
    gl_FrontColor = vec4(0.0, 0.0, 0.0, 0.0);
    
    float alpha = gl_FrontLightProduct[0].ambient[3];

    for (int i = 0; i < 2; i++){

	// xNg 
	vec3 lightVec = normalize(gl_LightSource[i].position.xyz/* - position*/);
	
	// ܂ł̋ 
	float dis = length(lightVec);
	
	lightVec = normalize(lightVec);
	
	/* W 
	   float attenuation = 1.0 / (gl_LightSource[0].constantAttenuation +
	   gl_LightSource[0].linearAttenuation * dis +
	   gl_LightSource[0].quadraticAttenuation * dis * dis);
	   float attenuation = 1.0;
	*/
	
	// fBt[Y 
	float diffuse = dot(lightVec, normal);
	
	// ArGg 
	gl_FrontColor += gl_FrontLightProduct[i].ambient;
	
	if (diffuse > 0.0){
#if USE_REFLECTION
	    // ˃xNgɂXyL[ 
	    vec3 viewVec = normalize(-position);
	    vec3 reflectVec = reflect(-lightVec, normal);
	    float specular = pow(max(dot(viewVec, reflectVec), 0.0), 
				 gl_FrontMaterial.shininess);
#else
	    // n[txNgɂXyL[ 
	    vec3 viewVec = normalize(-position);
	    vec3 halfVec = normalize(lightVec + viewVec);
	    float specular = pow(max(dot(normal, halfVec), 0.0), 
				 gl_FrontMaterial.shininess);
#endif
	    gl_FrontColor += 
		gl_FrontLightProduct[i].diffuse * diffuse
		+ gl_FrontLightProduct[i].specular * specular;
	}
    }
  
    gl_FrontColor[3] = alpha;

    gl_Position = ftransform();
}
